#include "opencv2/opencv.hpp"
#include <vector>
#include <string>
#include <iostream>

int main (int argc, char *argv[])
{
	cv::Mat image = cv::imread("../lena.jpg",cv::IMREAD_COLOR);
	if (image.empty()) return -1;
	
    cv::namedWindow("HSV filter", 0);
    int threshold_from = 0, threshold_to = 0;
    int last_from = 0, last_to = 0;
    cv::createTrackbar("from", "HSV filter", &threshold_from, 179, NULL);
    cv::createTrackbar("to", "HSV filter", &threshold_to, 179, NULL);
    cv::imshow("HSV filter",image);

    for (;;) {
        if (threshold_from != last_from || threshold_to != last_to) {
            last_from = threshold_from;
            last_to = threshold_to;

            cv::Mat hsv, mask, filtered;
            cv::cvtColor(image,hsv,cv::COLOR_BGR2HSV);
            cv::inRange(hsv, cv::Scalar(threshold_from, 120, 70), cv::Scalar(threshold_to, 255, 255), mask);
            filtered = image.clone();
            filtered.setTo(cv::Scalar(255,255,0),mask);
            cv::imshow("HSV filter",filtered);
        }

		int key = cv::waitKey(10);
		if (key == 27) break;
	}
	return 0;
}
